ideal
p386
locals
public          _main

include         "pmode\pmode.inc"
include         "sdrss.inc"
include         "plays3m.inc"

extrn           pannu : near
extrn           sslogo : near
extrn           scamel : near

macro           slabel  name, labelsize
                org     $-labelsize
                label   name labelsize
                org     $+labelsize
endm


segment         code32  para public use32
                assume  cs:code32, ds:code32

_main:          sti

                call    sd_initialize

                mov     eax,offset vrirq
                mov     [screensync],eax
                mov     eax,offset scamel
                mov     [module],eax
                call    initmusic

                mov     [v86r_ax],13h
                mov     ax,10h
                int     33h

                call    startmusic

                mov     eax,320*200
                call    _gethimem
                mov     [screenbuff],eax
                mov     ecx,320*200/4
                mov     edi,eax
                sub     eax,eax
                cld
                rep     stosd

                mov     esi,offset pannu+10
                mov     ecx,768
                mov     dx,3c8h
                sub     al,al
                out     dx,al
                inc     dx
                cld
                rep     outsb

@@waitesc:      call    waitretrace

                mov     esi,[screenbuff]
                mov     edi,0a0000h
                sub     edi,[_code32a]
                cld
                mov     ecx,320*200/4
                rep     movsd

                mov     edi,[screenbuff]
                mov     ebp,100
@@yblurr:       mov     edx,160
@@xblurr:       mov     eax,[edi]
                mov     cl,[blurrr]
                and     cl,7
                and     eax,0ffh
                mov     ebx,eax
                shl     eax,cl
                sub     eax,ebx
                shr     eax,cl
                mov     [edi],al
                inc     edi
                dec     edx
                jnz     @@xblurr
                add     edi,160
                dec     ebp
                jnz     @@yblurr

                call    rotatepic

                mov     esi,[screenbuff]
                lea     edi,[esi+160]
                mov     edx,100
@@ycopy1:       mov     ecx,160/4
@@xcopy1:       mov     eax,[esi]
                add     esi,4
                mov     [edi],eax
                add     edi,4
                dec     ecx
                jnz     @@xcopy1
                add     esi,160
                add     edi,160
                dec     edx
                jnz     @@ycopy1

                mov     esi,[screenbuff]
                lea     edi,[esi+320*100]
                mov     ecx,320*100/4
                rep     movsd

                call    putlogo

                in      al,60h
                cmp     al,1
                jne     @@waitesc

                mov     [v86r_ax],3h
                mov     ax,10h
                int     33h

                call    stopmusic
                call    sd_uninitialize

                jmp     _exit

                align   4
vrirq:          add     [pickulma],1
                and     [pickulma],03ffh
                add     [zoom],1
                and     [zoom],01ffh
@@noneg:        ret

                align   4
putlogo:        mov     esi,offset sslogo+778
                mov     edi,[screenbuff]
                add     edi,320*152+252
                mov     edx,47
@@ycopy:        mov     ecx,67
@@xcopy:        mov     al,[esi]
                inc     esi
                test    al,al
                jz      @@noplot
                mov     [edi],al
@@noplot:       inc     edi
                dec     ecx
                jnz     @@xcopy
                add     edi,320-67
                dec     edx
                jnz     @@ycopy
                ret




blurrr          db      3
pickulma        dd      0
zoom            dd      0
                align   4
rotatepic:      mov     ecx,[pickulma]
                mov     eax,[sincostab+ecx*4]
                mov     ebx,[sincostab+ecx*4+1024]

                mov     ecx,[zoom]
                mov     ecx,[sincostab+ecx*4]
                sar     ecx,4

                imul    ecx
                xchg    eax,ebx
                imul    ecx

                sar     eax,8
                sar     ebx,8

                mov     [@@xincx],eax
                mov     [@@xincy],ebx
                mov     [@@yincy],ebx
                mov     [@@yincx],eax

                mov     ecx,1
                imul    ecx,eax,-128
                imul    ecx,ebx,-128

                mov     edx,1
                imul    edx,eax,128
                imul    edx,ebx,-128

                jmp     $+2

                mov     esi,[screenbuff]

                mov     ebp,50
@@yloop:        sub     ecx,12345678h
                slabel  @@yincx, dword
                add     edx,12345678h
                slabel  @@yincy, dword
                push    edx
                push    ecx
                push    ebp
                mov     ebp,80
@@xloop:        mov     ebx,edx
                sar     ebx,15
                mov     bh,bl
                mov     eax,ecx
                sar     eax,15
                mov     bl,al
                and     ebx,0ffffh
                mov     eax,[ebx+offset pannu+778]
                test    al,al
                jz      @@zero
                mov     ah,al
                shr     ah,1
                mov     [esi],eax
                mov     [esi+321],eax
@@zero:         add     esi,2
                add     edx,12345678h
                slabel  @@xincx, dword
                add     ecx,12345678h
                slabel  @@xincy, dword
                dec     ebp
                jnz     @@xloop
                add     esi,320+160
                pop     ebp
                pop     ecx
                pop     edx
                dec     ebp
                jnz     @@yloop
                ret

                align 4
waitretrace:    mov     dx,3dah
@@active:       in      al,dx
                test    al,8
                jnz      @@active
@@inactive:     in      al,dx
                test    al,8
                jz      @@inactive
                ret

                align   4
screenbuff      dd      ?
                align   4
sincostab       dd      0, 201, 402, 603, 804, 1005, 1206, 1407
                dd      1608, 1809, 2009, 2210, 2411, 2611, 2811, 3012
                dd      3212, 3412, 3612, 3812, 4011, 4211, 4410, 4609
                dd      4808, 5007, 5205, 5404, 5602, 5800, 5998, 6195
                dd      6393, 6590, 6787, 6983, 7180, 7376, 7571, 7767
                dd      7962, 8157, 8351, 8546, 8740, 8933, 9127, 9319
                dd      9512, 9704, 9896, 10088, 10279, 10469, 10660, 10850
                dd      11039, 11228, 11417, 11605, 11793, 11980, 12167, 12354
                dd      12540, 12725, 12910, 13095, 13279, 13463, 13646, 13828
                dd      14010, 14192, 14373, 14553, 14733, 14912, 15091, 15269
                dd      15447, 15624, 15800, 15976, 16151, 16326, 16500, 16673
                dd      16846, 17018, 17190, 17361, 17531, 17700, 17869, 18037
                dd      18205, 18372, 18538, 18703, 18868, 19032, 19195, 19358
                dd      19520, 19681, 19841, 20001, 20160, 20318, 20475, 20632
                dd      20788, 20943, 21097, 21251, 21403, 21555, 21706, 21856
                dd      22006, 22154, 22302, 22449, 22595, 22740, 22884, 23028
                dd      23170, 23312, 23453, 23593, 23732, 23870, 24008, 24144
                dd      24279, 24414, 24548, 24680, 24812, 24943, 25073, 25202
                dd      25330, 25457, 25583, 25708, 25833, 25956, 26078, 26199
                dd      26320, 26439, 26557, 26674, 26791, 26906, 27020, 27133
                dd      27246, 27357, 27467, 27576, 27684, 27791, 27897, 28002
                dd      28106, 28209, 28311, 28411, 28511, 28610, 28707, 28803
                dd      28899, 28993, 29086, 29178, 29269, 29359, 29448, 29535
                dd      29622, 29707, 29792, 29875, 29957, 30038, 30118, 30196
                dd      30274, 30350, 30425, 30499, 30572, 30644, 30715, 30784
                dd      30853, 30920, 30986, 31050, 31114, 31177, 31238, 31298
                dd      31357, 31415, 31471, 31527, 31581, 31634, 31686, 31737
                dd      31786, 31834, 31881, 31927, 31972, 32015, 32058, 32099
                dd      32138, 32177, 32214, 32251, 32286, 32319, 32352, 32383
                dd      32413, 32442, 32470, 32496, 32522, 32546, 32568, 32590
                dd      32610, 32629, 32647, 32664, 32679, 32693, 32706, 32718
                dd      32729, 32738, 32746, 32753, 32758, 32762, 32766, 32767
                dd      32767, 32767, 32766, 32762, 32758, 32753, 32746, 32738
                dd      32729, 32718, 32706, 32693, 32679, 32664, 32647, 32629
                dd      32610, 32590, 32568, 32546, 32522, 32496, 32470, 32442
                dd      32413, 32383, 32352, 32319, 32286, 32251, 32214, 32177
                dd      32138, 32099, 32058, 32015, 31972, 31927, 31881, 31834
                dd      31786, 31737, 31686, 31634, 31581, 31527, 31471, 31415
                dd      31357, 31298, 31238, 31177, 31114, 31050, 30986, 30920
                dd      30853, 30784, 30715, 30644, 30572, 30499, 30425, 30350
                dd      30274, 30196, 30118, 30038, 29957, 29875, 29792, 29707
                dd      29622, 29535, 29448, 29359, 29269, 29178, 29086, 28993
                dd      28899, 28803, 28707, 28610, 28511, 28411, 28311, 28209
                dd      28106, 28002, 27897, 27791, 27684, 27576, 27467, 27357
                dd      27246, 27133, 27020, 26906, 26791, 26674, 26557, 26439
                dd      26320, 26199, 26078, 25956, 25833, 25708, 25583, 25457
                dd      25330, 25202, 25073, 24943, 24812, 24680, 24548, 24414
                dd      24279, 24144, 24008, 23870, 23732, 23593, 23453, 23312
                dd      23170, 23028, 22884, 22740, 22595, 22449, 22302, 22154
                dd      22006, 21856, 21706, 21555, 21403, 21251, 21097, 20943
                dd      20788, 20632, 20475, 20318, 20160, 20001, 19841, 19681
                dd      19520, 19358, 19195, 19032, 18868, 18703, 18538, 18372
                dd      18205, 18037, 17869, 17700, 17531, 17361, 17190, 17018
                dd      16846, 16673, 16500, 16326, 16151, 15976, 15800, 15624
                dd      15447, 15269, 15091, 14912, 14733, 14553, 14373, 14192
                dd      14010, 13828, 13646, 13463, 13279, 13095, 12910, 12725
                dd      12540, 12354, 12167, 11980, 11793, 11605, 11417, 11228
                dd      11039, 10850, 10660, 10469, 10279, 10088, 9896, 9704
                dd      9512, 9319, 9127, 8933, 8740, 8546, 8351, 8157
                dd      7962, 7767, 7571, 7376, 7180, 6983, 6787, 6590
                dd      6393, 6195, 5998, 5800, 5602, 5404, 5205, 5007
                dd      4808, 4609, 4410, 4211, 4011, 3812, 3612, 3412
                dd      3212, 3012, 2811, 2611, 2411, 2210, 2009, 1809
                dd      1608, 1407, 1206, 1005, 804, 603, 402, 201
                dd      0, -201, -402, -603, -804, -1005, -1206, -1407
                dd      -1608, -1809, -2009, -2210, -2411, -2611, -2811, -3012
                dd      -3212, -3412, -3612, -3812, -4011, -4211, -4410, -4609
                dd      -4808, -5007, -5205, -5404, -5602, -5800, -5998, -6195
                dd      -6393, -6590, -6787, -6983, -7180, -7376, -7571, -7767
                dd      -7962, -8157, -8351, -8546, -8740, -8933, -9127, -9319
                dd      -9512, -9704, -9896, -10088, -10279, -10469, -10660, -10850
                dd      -11039, -11228, -11417, -11605, -11793, -11980, -12167, -12354
                dd      -12540, -12725, -12910, -13095, -13279, -13463, -13646, -13828
                dd      -14010, -14192, -14373, -14553, -14733, -14912, -15091, -15269
                dd      -15447, -15624, -15800, -15976, -16151, -16326, -16500, -16673
                dd      -16846, -17018, -17190, -17361, -17531, -17700, -17869, -18037
                dd      -18205, -18372, -18538, -18703, -18868, -19032, -19195, -19358
                dd      -19520, -19681, -19841, -20001, -20160, -20318, -20475, -20632
                dd      -20788, -20943, -21097, -21251, -21403, -21555, -21706, -21856
                dd      -22006, -22154, -22302, -22449, -22595, -22740, -22884, -23028
                dd      -23170, -23312, -23453, -23593, -23732, -23870, -24008, -24144
                dd      -24279, -24414, -24548, -24680, -24812, -24943, -25073, -25202
                dd      -25330, -25457, -25583, -25708, -25833, -25956, -26078, -26199
                dd      -26320, -26439, -26557, -26674, -26791, -26906, -27020, -27133
                dd      -27246, -27357, -27467, -27576, -27684, -27791, -27897, -28002
                dd      -28106, -28209, -28311, -28411, -28511, -28610, -28707, -28803
                dd      -28899, -28993, -29086, -29178, -29269, -29359, -29448, -29535
                dd      -29622, -29707, -29792, -29875, -29957, -30038, -30118, -30196
                dd      -30274, -30350, -30425, -30499, -30572, -30644, -30715, -30784
                dd      -30853, -30920, -30986, -31050, -31114, -31177, -31238, -31298
                dd      -31357, -31415, -31471, -31527, -31581, -31634, -31686, -31737
                dd      -31786, -31834, -31881, -31927, -31972, -32015, -32058, -32099
                dd      -32138, -32177, -32214, -32251, -32286, -32319, -32352, -32383
                dd      -32413, -32442, -32470, -32496, -32522, -32546, -32568, -32590
                dd      -32610, -32629, -32647, -32664, -32679, -32693, -32706, -32718
                dd      -32729, -32738, -32746, -32753, -32758, -32762, -32766, -32767
                dd      -32767, -32767, -32766, -32762, -32758, -32753, -32746, -32738
                dd      -32729, -32718, -32706, -32693, -32679, -32664, -32647, -32629
                dd      -32610, -32590, -32568, -32546, -32522, -32496, -32470, -32442
                dd      -32413, -32383, -32352, -32319, -32286, -32251, -32214, -32177
                dd      -32138, -32099, -32058, -32015, -31972, -31927, -31881, -31834
                dd      -31786, -31737, -31686, -31634, -31581, -31527, -31471, -31415
                dd      -31357, -31298, -31238, -31177, -31114, -31050, -30986, -30920
                dd      -30853, -30784, -30715, -30644, -30572, -30499, -30425, -30350
                dd      -30274, -30196, -30118, -30038, -29957, -29875, -29792, -29707
                dd      -29622, -29535, -29448, -29359, -29269, -29178, -29086, -28993
                dd      -28899, -28803, -28707, -28610, -28511, -28411, -28311, -28209
                dd      -28106, -28002, -27897, -27791, -27684, -27576, -27467, -27357
                dd      -27246, -27133, -27020, -26906, -26791, -26674, -26557, -26439
                dd      -26320, -26199, -26078, -25956, -25833, -25708, -25583, -25457
                dd      -25330, -25202, -25073, -24943, -24812, -24680, -24548, -24414
                dd      -24279, -24144, -24008, -23870, -23732, -23593, -23453, -23312
                dd      -23170, -23028, -22884, -22740, -22595, -22449, -22302, -22154
                dd      -22006, -21856, -21706, -21555, -21403, -21251, -21097, -20943
                dd      -20788, -20632, -20475, -20318, -20160, -20001, -19841, -19681
                dd      -19520, -19358, -19195, -19032, -18868, -18703, -18538, -18372
                dd      -18205, -18037, -17869, -17700, -17531, -17361, -17190, -17018
                dd      -16846, -16673, -16500, -16326, -16151, -15976, -15800, -15624
                dd      -15447, -15269, -15091, -14912, -14733, -14553, -14373, -14192
                dd      -14010, -13828, -13646, -13463, -13279, -13095, -12910, -12725
                dd      -12540, -12354, -12167, -11980, -11793, -11605, -11417, -11228
                dd      -11039, -10850, -10660, -10469, -10279, -10088, -9896, -9704
                dd      -9512, -9319, -9127, -8933, -8740, -8546, -8351, -8157
                dd      -7962, -7767, -7571, -7376, -7180, -6983, -6787, -6590
                dd      -6393, -6195, -5998, -5800, -5602, -5404, -5205, -5007
                dd      -4808, -4609, -4410, -4211, -4011, -3812, -3612, -3412
                dd      -3212, -3012, -2811, -2611, -2411, -2210, -2009, -1809
                dd      -1608, -1407, -1206, -1005, -804, -603, -402, -201
                dd      0, 201, 402, 603, 804, 1005, 1206, 1407
                dd      1608, 1809, 2009, 2210, 2411, 2611, 2811, 3012
                dd      3212, 3412, 3612, 3812, 4011, 4211, 4410, 4609
                dd      4808, 5007, 5205, 5404, 5602, 5800, 5998, 6195
                dd      6393, 6590, 6787, 6983, 7180, 7376, 7571, 7767
                dd      7962, 8157, 8351, 8546, 8740, 8933, 9127, 9319
                dd      9512, 9704, 9896, 10088, 10279, 10469, 10660, 10850
                dd      11039, 11228, 11417, 11605, 11793, 11980, 12167, 12354
                dd      12540, 12725, 12910, 13095, 13279, 13463, 13646, 13828
                dd      14010, 14192, 14373, 14553, 14733, 14912, 15091, 15269
                dd      15447, 15624, 15800, 15976, 16151, 16326, 16500, 16673
                dd      16846, 17018, 17190, 17361, 17531, 17700, 17869, 18037
                dd      18205, 18372, 18538, 18703, 18868, 19032, 19195, 19358
                dd      19520, 19681, 19841, 20001, 20160, 20318, 20475, 20632
                dd      20788, 20943, 21097, 21251, 21403, 21555, 21706, 21856
                dd      22006, 22154, 22302, 22449, 22595, 22740, 22884, 23028
                dd      23170, 23312, 23453, 23593, 23732, 23870, 24008, 24144
                dd      24279, 24414, 24548, 24680, 24812, 24943, 25073, 25202
                dd      25330, 25457, 25583, 25708, 25833, 25956, 26078, 26199
                dd      26320, 26439, 26557, 26674, 26791, 26906, 27020, 27133
                dd      27246, 27357, 27467, 27576, 27684, 27791, 27897, 28002
                dd      28106, 28209, 28311, 28411, 28511, 28610, 28707, 28803
                dd      28899, 28993, 29086, 29178, 29269, 29359, 29448, 29535
                dd      29622, 29707, 29792, 29875, 29957, 30038, 30118, 30196
                dd      30274, 30350, 30425, 30499, 30572, 30644, 30715, 30784
                dd      30853, 30920, 30986, 31050, 31114, 31177, 31238, 31298
                dd      31357, 31415, 31471, 31527, 31581, 31634, 31686, 31737
                dd      31786, 31834, 31881, 31927, 31972, 32015, 32058, 32099
                dd      32138, 32177, 32214, 32251, 32286, 32319, 32352, 32383
                dd      32413, 32442, 32470, 32496, 32522, 32546, 32568, 32590
                dd      32610, 32629, 32647, 32664, 32679, 32693, 32706, 32718
                dd      32729, 32738, 32746, 32753, 32758, 32762, 32766, 32767

ends            code32
end
