;͸͸
; Sd_GetConfig                                                              
;ľ                                            
;                                                                            
; In:  -                                                                     
;                                                                            
; Out: -                                                                     
;                                                                            
; Description: Get Configuration                                             
;                                                                            
;ľ
;  
                align   4
sd_getconfig:   mov     [sd_cardtype],0
                mov     [sd_base],0
                mov     [sd_irq],0
                mov     [sd_dma],0
                mov     [sd_mixrate],0
                pushad

                mov     [v86r_ax],0f00h
                mov     ax,10h
                int     33h
                movzx   ax,[v86r_al]
                mov     [@@oldmode],ax
                mov     ax,10h
                mov     [v86r_ax],3h
                int     33h

                call    sd_displaytitle
                call    sd_getcardtype
                cmp     [sd_cardtype],6
                je      @@done
                call    sd_getbase
                cmp     [sd_cardtype],1
                je      @@done
                call    sd_getirq
                call    sd_getdma
                call    sd_getmixrate
@@done:
                mov     ax,[@@oldmode]
                mov     [v86r_ax],ax
                mov     ax,10h
                int     33h

                popad
                ret

@@oldmode       dw      ?

                align   4
sd_displaytitle:pushad
                mov     eax,0b8000h
                sub     eax,[_code32a]
                mov     ecx,80
                mov     bx,1f00h
@@clear:        mov     [eax],bx
                add     eax,2
                dec     ecx
                jnz     @@clear
                mov     esi,offset @@title
                mov     eax,0b8002h
                sub     eax,[_code32a]
                mov     bh,16+15
@@print:        mov     bl,[esi]
                test    bl,bl
                jz      @@print_done
                mov     [eax],bx
                add     eax,2
                inc     esi
                jmp     @@print
@@print_done:   popad
                ret
@@title         db      "Slender's Sound System configuration menu",0

                align   4
sd_getcardtype: mov     eax,offset sd_cardmenu
                mov     bl,1
                call    sd_menu
                and     eax,0ffh
                movzx   eax,[@@list+eax*2]
                mov     [sd_cardtype],eax
                ret
@@list          dw      0,1,2,3,4,5,6

                align   4
sd_getbase:     mov     eax,offset sd_basemenu
                mov     bl,1
                call    sd_menu
                and     eax,0ffh
                mov     ax,[@@list+eax*2]
                mov     [sd_base],ax
                ret
@@list          dw      0,210h,220h,230h,240h,250h,260h

                align   4
sd_getirq:      mov     eax,offset sd_irqmenu
                mov     bl,1
                call    sd_menu
                and     eax,0ffh
                mov     ax,[@@list+eax*2]
                mov     [sd_irq],ax
                ret
@@list          dw      0,2,3,4,5,7,9,10,11,12,15

                align   4
sd_getdma:      mov     eax,offset sd_dmamenu
                mov     bl,1
                call    sd_menu
                and     eax,0ffh
                mov     ax,[@@list+eax*2]
                mov     [sd_dma],ax
                ret
@@list          dw      0,0,1,3,5,6,7

                align   4
sd_getmixrate:  mov     eax,offset sd_mixmenu
                mov     bl,1
                call    sd_menu
                and     eax,0ffh
                mov     eax,[@@list+eax*4]
                mov     [sd_mixrate],eax
                ret
@@list          dd      0,4000,8000,11025,16000,22050,32000,38000,44100

;͸͸
; _Menu                                                                     
;ľ                                            
;                                                                            
; In:  eax - menu structure                                                  
;      bl  - menu starting position                                          
;                                                                            
; Out: al - selected menu position                                           
;                                                                            
; Description:                                                               
;                                                                            
;ľ
;  
                align   4
sd_menu:        pushad

                dec     bl
                mov     [@@menupos],bl
                push    eax

                mov     eax,0b80a0h
                sub     eax,[_code32a]
                mov     ecx,160*24/2
                mov     ebx,0
@@clear:        mov     [eax],ebx
                add     eax,4
                dec     ecx
                jnz     @@clear

                mov     ax,[gs:460h]
                mov     [@@cursor],ax
                mov     [v86r_ah],1
                mov     [v86r_cx],2000h
                mov     ax,10h
                int     33h

                pop     eax

                call    @@printmenu

                mov     al,[@@menucolor2]
                call    @@colorpalkki

                call    @@initkb

@@menuloop:     cmp     [@@hit],0
                je      @@menuloop
                mov     [@@hit],0
                mov     al,[@@char]
                cmp     al,48h
                je      @@uparrow
                cmp     al,50h
                je      @@downarrow
                cmp     al,01h
                je      @@exit
                cmp     al,1ch
                jne     @@menuloop

                call    @@resetkb

                mov     ax,[@@cursor]
                mov     [v86r_ah],1
                mov     [v86r_cx],ax
                mov     ax,10h
                int     33h

                popad
                mov     al,[@@menupos]
                inc     al
                ret

@@exit:         call    @@resetkb
                popad
                mov     [v86r_ax],3h
                mov     ax,10h
                int     33h
                jmp     _exit

                align   4
@@uparrow:      cmp     [@@menupos],0
                je      @@menuloop
                mov     al,[@@menucolor1]
                call    @@colorpalkki
                dec     [@@menupos]
                mov     al,[@@menucolor2]
                call    @@colorpalkki
                jmp     @@menuloop

                align   4
@@downarrow:    mov     al,[@@menumax]
                cmp     [@@menupos],al
                je      @@menuloop
                mov     al,[@@menucolor1]
                call    @@colorpalkki
                inc     [@@menupos]
                mov     al,[@@menucolor2]
                call    @@colorpalkki
                jmp     @@menuloop

                align   4
@@printmenu:    mov     esi,eax
                movzx   eax,[byte esi+1]
                mov     ecx,160
                mul     ecx
                movzx   ecx,[byte esi]
                lea     eax,[ecx*2+eax]
                mov     bh,[esi+2]
                add     esi,3
                call    @@printasciiz
@@printmenu_1:  cmp     [byte esi],0
                je      @@printmenu_2
                inc     esi
                jmp     @@printmenu_1
@@printmenu_2:  inc     esi
                mov     al,[esi]
                mov     [@@menucolor1],al
                mov     al,[esi+1]
                mov     [@@menucolor2],al
                movzx   eax,[byte esi+2]
                mov     [@@menustart],al
                mov     ecx,160
                mul     ecx
                mov     edi,eax
                add     esi,3
                mov     [@@menumax],-1
@@printmenu_6:  inc     [@@menumax]
                movzx   ecx,[byte esi]
                inc     esi
                lea     eax,[edi+ecx*2]
                mov     bh,[@@menucolor1]
                call    @@printasciiz
@@printmenu_3:  cmp     [byte esi],0
                je      @@printmenu_4
                inc     esi
                jmp     @@printmenu_3
@@printmenu_4:  inc     esi
                cmp     [byte esi],0ffh
                je      @@printmenu_5
                add     edi,160
                jmp     @@printmenu_6
@@printmenu_5:  ret

; al - color
                align   4
@@colorpalkki:  push    ax
                movzx   eax,[@@menustart]
                movzx   ebx,[@@menupos]
                add     eax,ebx
                mov     ebx,160
                mul     ebx
                pop     bx
                add     eax,0b8001h
                sub     eax,[_code32a]
                mov     ecx,80
@@drawpalkki_1: mov     [eax],bl
                add     eax,2
                dec     ecx
                jnz     @@drawpalkki_1
                ret

;
; esi - string
; eax - offset
; bh  - attribute
;
                align   4
@@printasciiz:  push    eax ebx esi
                add     eax,0b8000h
                sub     eax,[_code32a]
@@print:        mov     bl,[esi]
                test    bl,bl
                jz      @@print_done
                mov     [eax],bx
                add     eax,2
                inc     esi
                jmp     @@print
@@print_done:   pop     esi ebx eax
                ret

                align   4
@@initkb:       cli
                mov     bl,1
                call    _getirqmask
                mov     [@@oldmask],al
                sub     al,al
                call    _setirqmask
                call    [_getirqvect]
                mov     [@@oldpmirq],edx
                mov     edx,offset @@irq1
                call    [_setirqvect]
                mov     edi,offset @@stub
                call    _rmpmirqset
                mov     [@@oldrmirq],eax
                mov     [@@hit],0
                sti
                ret

                align   4
@@resetkb:      cli
                mov     bl,1
                mov     al,[@@oldmask]
                call    _setirqmask
                mov     edx,[@@oldpmirq]
                call    [_setirqvect]
                mov     eax,[@@oldrmirq]
                call    _rmpmirqfree
                sti
                ret

                align   4
@@irq1:         pushad
                mov     [@@hit],1
                in      al,60h
                mov     [@@char],al
                mov     al,20h
                out     20h,al
                popad
                iretd

                align   4
@@cursor        dw      ?
@@oldpmirq      dd      ?
@@oldrmirq      dd      ?
@@oldmask       db      ?
@@hit           db      ?
@@char          db      ?
@@stub          db      21 dup(?)
@@menupos       db      ?
@@menustart     db      ?
@@menucolor1    db      ?
@@menucolor2    db      ?
@@menumax       db      ?


;
; menu structure:
;
;  db   x, y attribute
;  db   'title',0
;  db   attribute, menubar attribute
;  db   y
;  db   x,'menuitem1',1
;  db   x,'menuitem2',1
;  db   x,'menuitem3',1
;  db   x,'menuitem.',1
;  db   x,'menuitem.',1
;  db   x,'menuitemX',1
;  db   0ffh                       ; end of menu
;

                align   4
sd_cardmenu     db      31,4,11
                db      'Select Sound Card',0
                db      7,15
                db      7
                db      24,'Gravis Ultrasound (GF1) ]STEREO[',0
                db      21,'Sound Blaster PRO (DSP v3.xx) ]STEREO[',0
                db      22,'Sound Blaster 2.0 (DSP v2.01) [MONO]',0
                db      22,'Sound Blaster 1.5 (DSP v2.00) [MONO]',0
                db      17,'Sound Blaster 1.0 or clone (DSP v1.xx) [MONO]',0
                db      36,'No Sound',0
                db      0ffh

                align   4
sd_basemenu     db      24,4,11
                db      'Select Sound Card I/O Address Port',0
                db      7,15
                db      7
                db      38,'210h',0
                db      38,'220h',0
                db      38,'230h',0
                db      38,'240h',0
                db      38,'250h',0
                db      38,'260h',0
                db      0ffh

                align   4
sd_irqmenu      db      27,4,11
                db      'Select Sound Card IRQ Number',0
                db      7,15
                db      7
                db      39,'2',0
                db      39,'3',0
                db      39,'4',0
                db      39,'5',0
                db      39,'7',0
                db      39,'9',0
                db      38,'10',0
                db      38,'11',0
                db      38,'12',0
                db      38,'15',0
                db      0ffh

                align   4
sd_dmamenu      db      27,4,11
                db      'Select Sound Card DMA Channel',0
                db      7,15
                db      7
                db      39,'0',0
                db      39,'1',0
                db      39,'3',0
                db      39,'5',0
                db      39,'6',0
                db      39,'7',0
                db      0ffh

                align   4
sd_mixmenu      db      28,4,11
                db      'Select Software Mixing Rate',0
                db      7,15
                db      7
                db      37,'4000Hz',0
                db      37,'8000Hz',0
                db      36,'11025Hz',0
                db      36,'16000Hz',0
                db      36,'22050Hz',0
                db      36,'32000Hz',0
                db      36,'38000Hz',0
                db      36,'44100Hz',0
                db      0ffh
