;͸͸
; Sd_LoadConfig                                                             
;ľ                                            
;                                                                            
; In:  edx - configuration filename                                          
;                                                                            
; Out: -                                                                     
;                                                                            
; Description: Load configuration from file                                  
;                                                                            
;ľ
;  
                align   4
sd_loadconfig:  pushad
                call    _openfile
                jc      @@nofile
                mov     edx,offset sd_config
                mov     ecx,14
                call    _readfile
                call    _closefile
                popad
                ret

@@nofile:       mov     [sd_cardtype],6
                mov     edx,offset @@errormsg
                call    _printstr
                popad
                ret

@@errormsg      db      'SDRSS ERROR: Configuration file not found, using No Sound device!',13,10,'$'

                align   4
_printstr:      add     edx,[_code32a]
                mov     ax,dx
                shr     edx,4
                and     ax,0fh
                mov     [v86r_dx],ax
                mov     [v86r_ds],dx
                mov     [v86r_ah],9
                mov     ax,21h
                int     33h
                ret

masm
;
; DATA
;
_filebufloc     dd      0               ; location must be in low mem
_filebuflen     dw      1000h

;
; CODE
;

;
; Open file
; In:
;   EDX -> ASCIIZ filename
; Out:
;   CF=1 - Error opening file
;   CF=0 - File opened succesfully
;     V86R_BX - file handle
;
_openfile:
        push ax
        push edx
        add edx,_code32a
        mov ax,dx
        shr edx,4
        and ax,0fh
        mov v86r_dx,ax
        mov v86r_ds,dx
        mov v86r_ax,3d02h
        mov al,21h
        int 33h
        mov ax,v86r_ax
        mov v86r_bx,ax
        pop edx
        pop ax
        ret

;
; Close a file
; In:
;   V86R_BX - file handle
;   CF=1 - Error closing file
;   CF=0 - File closed succesfully
;
_closefile:
        push ax
        mov v86r_ax,3e00h
        mov al,21h
        int 33h
        pop ax
        ret

;
; Read from file
; In:
;   V86R_BX - file handle
;   EDX -> buffer to read to
;   ECX - number of bytes to read
; Out:
;   CF=1 - Error reading file
;     EAX - ?
;   CF=0 - Read went fine
;     EAX - number of bytes read
;
_readfile:
        pushad
        xor ebp,ebp
        add edx,_code32a
        lea ebx,[ecx+edx]
        cmp ebx,100000h
        ja readlong
        mov eax,edx
        shr eax,4
        and dx,0fh
        mov v86r_ds,ax
        mov v86r_dx,dx
readl:
        mov eax,0fff0h
        cmp eax,ecx
        jbe readlf1
        mov eax,ecx
readlf1:
        mov v86r_cx,ax
        mov v86r_ax,3f00h
        mov al,21h
        int 33h
        jc readdone2
        movzx ebx,v86r_ax
        add ebp,ebx
        sub ecx,ebx
        jbe readdone
        or ebx,ebx
        jz readdone
        add v86r_ds,0fffh
        jmp readl
readlong:
        mov edi,edx
        sub edi,_code32a
        mov edx,ecx
        mov eax,_filebufloc
        add eax,_code32a
        mov ebx,eax
        shr eax,4
        and bx,0fh
        mov v86r_ds,ax
        mov v86r_dx,bx
        movzx ebx,_filebuflen
readlongl:
        mov eax,ebx
        cmp eax,edx
        jbe readlonglf1
        mov eax,edx
readlonglf1:
        mov v86r_cx,ax
        mov v86r_ax,3f00h
        mov al,21h
        int 33h
        jc short readdone2
        movzx ecx,v86r_ax
        add ebp,ecx
        mov eax,ecx
        or eax,eax
        jz readdone
        mov esi,_filebufloc
        rep movsb
        sub edx,eax
        ja readlongl
readdone:
        clc
readdone2:
        mov [esp+28],ebp
        popad
        ret
ideal

