;
;               Copyright (c)1995 Juha Pohto
;
;
; Filename   : PLAYS3M.ASM
; Author     : Juha Pohto
; Date       : 950715
; Description: PLAY ScreamTracker v3.20 Modules
;              Using Slender's Sound System Sound Device
; Version    : 1.04
;
; 1.01 - Bug fixed from tempo setting routine (thanx Welmu)
; 1.02 - Bug fixed from command Exx and Fxx
; 1.03 - Minor changes made and the result is:
;         *playing routine is MUCH! faster (especially with GUS)
;         *Awfull 'clicks' and 'pops' eliminated. Some may
;          still occur coz' I don't use volume ramping, I just
;          turn the volume down, but it's still a way better than
;          before!
; 1.04 - Totally pissed off with clicking. Now ultra clicks are
;        totally removed with volumeramps!
;

ideal
locals
p386

; PMODE externals
extrn   v86r_eax:dword, v86r_ebx:dword, v86r_ecx:dword, v86r_edx:dword
extrn   v86r_esi:dword, v86r_edi:dword, v86r_ebp:dword
extrn   v86r_ah:byte, v86r_al:byte, v86r_bh:byte, v86r_bl:byte
extrn   v86r_ch:byte, v86r_cl:byte, v86r_dh:byte, v86r_dl:byte
extrn   v86r_ax:word, v86r_bx:word, v86r_cx:word, v86r_dx:word
extrn   v86r_si:word, v86r_di:word, v86r_bp:word
extrn   v86r_ds:word, v86r_es:word, v86r_fs:word, v86r_gs:word
extrn   _selcode:word, _seldata:word, _selzero:word, _lomembase:dword
extrn   _lomemtop:dword, _himembase:dword, _himemtop:dword, _pspa:dword
extrn   _code16a:dword, _code32a:dword, _getirqvect:dword, _setirqvect:dword
extrn   _sysbyte0:byte, _irqmode:word, _setselector:dword, _exitcode:byte
extrn   _getmem:near, _getlomem:near, _gethimem:near, _lomemsize:near
extrn   _himemsize:near, _ret:near, _exit:near, _getirqmask:near
extrn   _setirqmask:near, _rmpmirqset:near, _rmpmirqfree:near
extrn   _getselector:near, _freeselector:near

include         "sdrss.inc"
include         "settings.inc"
include         "macros.inc"

segment_sdrss   %sdrss_segname

public          initmusic                       ; procedure
public          startmusic                      ; procedure
public          stopmusic                       ; procedure
public          screensync                      ; dword
public          module                          ; dword
public          mastervolume                    ; byte
public          order                           ; word
public          pattrow                         ; byte
public          tempo                           ; byte
public          speed                           ; byte
public          position_flag                   ; byte
public          row_note                        ; byte
public          row_instrument                  ; byte
public          row_volume                      ; byte
public          row_command                     ; byte
public          row_cinfo                       ; byte

                align   16
position_flag   db      ?                               ; used by command Mxx

                align   4
module          dd      ?                               ; module adderss
drambase        dd      ?

musictimer      dd      0
screentimer     dd      0
playirqcount    dd      0
screenirqcount  dd      0

screensync      dd      offset no_sync                  ; routine synchronized with screen vertical retrace rate

oldirq          dd      ?
oldrmirq        dd      ?
stubbuf         db      21 dup(?)

globalvolume    db      ?                               ; current global volume
speed           db      ?                               ; current speed
speedcount      db      ?                               ; counter for speed
pattdelaycount  db      ?                               ; counter for pattern delay
tempo           db      ?                               ; current tempo
                align   4
mastervolume    db      64                              ; current master volume (for fades)

                align   4
order           dw      ?                               ; current order
pattrow         db      ?                               ; current pattern row

                align   4
patternpos      dd      ?                               ; current song address
patterns        dd      99 dup(?)                       ; patterns addresses

                align   4
sample_start    dd      99 dup(0)
sample_loop     dd      99 dup(0)
sample_end      dd      99 dup(0)
sample_c2spd    dd      99 dup(8363)
sample_volume   db      99 dup(64)
sample_flags    db      99 dup(0)

sd_setfreq      =       1
sd_setvol       =       2
sd_setpan       =       4
sd_setsample    =       8
sd_setloop      =       16
sd_setend       =       32
sd_setmode      =       64

; variables to tranfer to sound device every frame
sd_status       db      16 dup(0)
sd_freq         dd      16 dup(0)
sd_vol          db      16 dup(0)
sd_pan          db      16 dup(0)
sd_start        dd      16 dup(0)
sd_loop         dd      16 dup(0)
sd_end          dd      16 dup(0)
sd_mode         db      16 dup(0)

; depacked row
row_note        db      16 dup(?)
row_instrument  db      16 dup(?)
row_volume      db      16 dup(?)
row_command     db      16 dup(?)
row_cinfo       db      16 dup(?)

chan_note       db      16 dup(255)
chan_instrument db      16 dup(0)
chan_volume     db      16 dup(255)

                align   4
chan_start      dd      16 dup(?)
chan_period     dd      16 dup(?)

; toneportamento variables
                align   4
chan_toperiod   dd      16 dup(?)
chan_toneporta  db      16 dup(?)

; sample offset variables
                align   4
chan_smpoffset  db      16 dup(?)

; arpeggio variables
                align   4
chan_arpeggio   db      16 dup(?)
chan_arppos     db      16 dup(?)
                align   4
chan_arpper1    dd      16 dup(?)               ; note
chan_arpper2    dd      16 dup(?)               ; note + 1st halfnote
chan_arpper3    dd      16 dup(?)               ; note + 2nd halfnote

; volumeslide variables
                align   4
chan_volslide   db      16 dup(?)

; slidedown vars
                align   4
chan_slidedown  db      16 dup(?)

; slideup vars
                align   4
chan_slideup    db      16 dup(?)

; vibrato vars
                align   4
chan_vibrato    db      16 dup(?)
chan_vibratopos db      16 dup(?)

chan_vibvslide  db      16 dup(?)

chan_tpvslide   db      16 dup(?)

sintable        db      0,12,25,37,49,60,71,81,90,98,106,112,117,122,125
                db      126,127,126,125,122,117,112,106,98,90,81,71,60,49
                db      37,25,12,0,-12,-25,-37,-49,-60,-71,-81,-90,-98,-106
                db      -112,-117,-122,-125,-126,-127,-126,-125,-122,-117,-112
                db      -106,-98,-90,-81,-71,-60,-49,-37,-25,-12

                align   4
timervalues     dw      64880,64880,64880,64880,64880,64880,64880,64880
                dw      64880,64880,64880,64880,64880,64880,64880,64880
                dw      64880,64880,64880,64880,64880,64880,64880,64880
                dw      64880,64880,64880,64880,64880,64880,64880,64880
                dw      64880,64880,64880,64880,64880,64880,64880,64880
                dw      64880,64880,64880,64880,64880,64880,64880,63500
                dw      62177,60908,59690,58519,57394,56311,55268,54264
                dw      53295,52360,51457,50585,49742,48926,48137,47373
                dw      46633,45915,45220,44545,43890,43254,42636,42035
                dw      41451,40883,40331,39793,39270,38760,38263,37778
                dw      37306,36846,36396,35958,35530,35112,34703,34305
                dw      33915,33534,33161,32797,32440,32091,31750,31416
                dw      31088,30768,30454,30146,29845,29549,29260,28976
                dw      28697,28424,28156,27892,27634,27381,27132,26887
                dw      26647,26411,26180,25952,25728,25508,25292,25080
                dw      24871,24665,24463,24264,24068,23876,23686,23500
                dw      23316,23136,22958,22782,22610,22440,22272,22107
                dw      21945,21785,21627,21471,21318,21167,21018,20871
                dw      20726,20583,20442,20303,20165,20030,19897,19765
                dw      19635,19506,19380,19255,19131,19010,18889,18770
                dw      18653,18537,18423,18310,18198,18088,17979,17871
                dw      17765,17660,17556,17453,17352,17251,17152,17054
                dw      16957,16862,16767,16673,16581,16489,16398,16309
                dw      16220,16132,16046,15960,15875,15791,15708,15626
                dw      15544,15464,15384,15305,15227,15150,15073,14997
                dw      14922,14848,14775,14702,14630,14559,14488,14418
                dw      14349,14280,14212,14145,14078,14012,13946,13881
                dw      13817,13753,13690,13628,13566,13504,13444,13383
                dw      13324,13264,13206,13148,13090,13033,12976,12920
                dw      12864,12809,12754,12700,12646,12593,12540,12487
                dw      12435,12384,12333,12282,12232,12182,12132,12083
                dw      12034,11986,11938,11890,11843,11796,11750,11704

;͸͸
; InitMusic                                                                 
;ľ                                            
;                                                                            
; In:  -                                                                     
;                                                                            
; Out: eax - Error Number 00: No Error                                       
;                         01: Form of file was wrong                         
;                         02: Not enought dram                               
;                         03: No default pannings                            
;                                                                            
; Description: Initialize SoundDevice for playing                            
;                                                                            
;ľ
;  
                align   4
initmusic:      pushad

                mov     ebx,[module]

                ; check form
                mov     [@@errnum],1
                cmp     [dword ebx+2ch],"MRCS"
                jne     @@error

                ; check d.p
                mov     [@@errnum],3
                cmp     [dword ebx+35h],252
                jne     @@error

                ; init variables
                mov     al,[ebx+30h]
                mov     [globalvolume],al
                mov     al,[ebx+31h]
                mov     [speed],al
                mov     al,[ebx+32h]
                mov     [tempo],al
                mov     [order],0
                mov     [pattrow],64
                mov     [speedcount],1
                mov     [pattdelaycount],0

                ; upload samples
                mov     [@@errnum],2
                sub     eax,eax
                sub     ecx,ecx
                mov     cx,[ebx+22h]
@@upload:       call    upload_sample
                jnc     @@noerror
                jmp     @@error
@@noerror:      inc     eax
                dec     ecx
                jnz     @@upload

                ; calculate real pattern addresses
                call    setpatterns

                ; set panpositions
                call    setpannings

                popad
                sub     eax,eax
                ret

@@error:        popad
                mov     eax,[@@errnum]
                ret

                align   4
@@errnum        dd      ?

;͸͸
; UpLoad_Sample                                                             
;ľ                                            
;                                                                            
; In:  eax - samplenumber                                                    
;                                                                            
; Out: cf - errorflag (0:no error, 1:error!)                                 
;                                                                            
; Description: Upload sample to dram                                         
;                                                                            
;ľ
;  
                align   4
upload_sample:  pushad

                ; ebx - instrument header adderss
                mov     ebx,[module]
                sub     ecx,ecx
                mov     cx,[ebx+20h]
                lea     ebx,[ebx+ecx+60h]
                mov     bx,[ebx+eax*2]
                and     ebx,0ffffh
                shl     ebx,4
                add     ebx,[module]

                ; is it sample?
                cmp     [byte ebx],1
                jne     @@notsample

                ; allocate dram for sample, edi - dram address, ecx - sample size
                push    eax
                mov     ax,[ebx+12h]
                shl     eax,16
                mov     ax,[ebx+10h]
                mov     ecx,eax
                call    sd_getmem
                jc      @@nomem
                mov     edi,eax
                pop     eax

                ; save sample starting address
                mov     [sample_start+eax*4],edi

                ; save loopbeg
                mov     dx,[ebx+16h]
                shl     edx,16
                mov     dx,[ebx+14h]
                add     edx,edi
                mov     [sample_loop+eax*4],edx

                ; save end
                mov     dx,[ebx+1ah]
                shl     edx,16
                mov     dx,[ebx+18h]
                add     edx,edi
                dec     edx
                mov     [sample_end+eax*4],edx

                ; save volume
                mov     dl,[ebx+1ch]
                mov     [sample_volume+eax],dl

                ; save flags
                mov     dl,[ebx+1fh]
                mov     [sample_flags+eax],8
                test    dl,1
                jnz     @@loop_on
                mov     [sample_flags+eax],0
                lea     edx,[ecx+edi]
                dec     edx
                mov     [sample_end+eax*4],edx
@@loop_on:
                ; save c2spd
                mov     dx,[ebx+22h]
                shl     edx,16
                mov     dx,[ebx+20h]
                mov     [sample_c2spd+eax*4],edx

                ; esi - sampledata address
                sub     esi,esi
                mov     si,[ebx+0eh]
                shl     esi,4
                add     esi,[module]

                ; upload sampledata from mem to dram
@@upload:       mov     al,[esi]
                inc     esi
                sub     al,128
                call    sd_pokedata
                inc     edi
                dec     ecx
                jnz     @@upload

@@notsample:    popad
                clc
                ret

@@nomem:        pop     eax
                popa
                ret

;͸͸
; SetPatterns                                                               
;ľ                                            
;                                                                            
; In:  -                                                                     
;                                                                            
; Out: -                                                                     
;                                                                            
; Description: Calculate patterns addresses                                  
;                                                                            
;ľ
;  
                align   4
setpatterns:    sub     eax,eax
                mov     ax,[ebx+20h]
                sub     edx,edx
                mov     dx,[ebx+22h]
                lea     eax,[eax+edx*2+60h]
                add     eax,ebx

                sub     ecx,ecx
                mov     cx,[ebx+24h]

                mov     esi,[module]
                sub     edi,edi
@@loop:         sub     edx,edx
                mov     dx,[eax]
                shl     edx,4
                add     edx,ebx
                mov     [patterns+edi],edx
                add     eax,2
                add     edi,4
                dec     ecx
                jnz     @@loop
                ret

setpannings:    mov     edx,60h
                sub     ecx,ecx
                mov     cx,[ebx+20h]
                add     edx,ecx
                mov     cx,[ebx+22h]
                add     ecx,ecx
                add     edx,ecx
                sub     ecx,ecx
                mov     cx,[ebx+24h]
                add     ecx,ecx
                add     edx,ecx
                add     edx,ebx

                sub     ecx,ecx
@@loop:         ; select voice
                mov     al,cl
                inc     al
                call    sd_selectvoice

                ; set pan position
                mov     al,[edx+ecx]
                and     al,0fh
                call    sd_panposition

                inc     ecx
                cmp     ecx,16
                jle     @@loop
                ret

;͸͸
; StartMusic                                                                
;ľ                                            
;                                                                            
; In:  -                                                                     
;                                                                            
; Out: -                                                                     
;                                                                            
; Description: Start play .S3M module                                        
;                                                                            
;ľ
;  
                align   4
startmusic:     pushad

                cli

                ; set tempo
                mov     al,[tempo]
                call    setirqrate

                ; set irqhandler
                call    setirqhandler

                ; start pit
                mov     ecx,timercount
                mov     al,36h
                out     43h,al
                mov     al,cl
                out     40h,al
                mov     al,ch
                out     40h,al

                sti

                popad
                ret


;͸͸
; StopMusic                                                                 
;ľ                                            
;                                                                            
; In:  -                                                                     
;                                                                            
; Out: -                                                                     
;                                                                            
; Description: Stop playing                                                  
;                                                                            
;ľ
;  
                align   4
stopmusic:      pushad

                call    sd_uninitialize

                call    restoreirqhandler

                popad
                ret

;͸͸
; SetIrqRate                                                                
;ľ                                            
;                                                                            
; In:  al - bpm                                                              
;                                                                            
; Out: -                                                                     
;                                                                            
; Description: Set music rate                                                
;                                                                            
;ľ
;  
                align   4
setirqrate:     push    eax
                and     eax,0ffh
                movzx   eax,[timervalues+eax*2]
                mov     [musictimer],eax
                pop     eax
                ret

;͸͸
; IrqHandler                                                                
;ľ                                            
;                                                                            
; In:  -                                                                     
;                                                                            
; Out: -                                                                     
;                                                                            
; Description: Handes Timer interrupt                                        
;                                                                            
;ľ
;  
                align   4
irqhandler:     pushad
                cli
                mov     al,20h
                out     20h,al

                ; handle screen sync interrupt
                mov     eax,[screentimer]
                cmp     [screenirqcount],eax
                jl      @@no_screen
                sub     [screenirqcount],eax
                call    [screensync]
@@no_screen:

                ; handle bpm interrupt
                mov     eax,[musictimer]
                cmp     [playirqcount],eax
                jl      @@no_music
                sub     [playirqcount],eax
                call    playmusic
@@no_music:

                ; update counters
                mov     eax,timercount
                add     [playirqcount],eax
                add     [screenirqcount],eax

                popad
                sti
                iretd

                align   4
no_sync:        ret


;͸͸
; SetIrqHandler                                                             
;ľ                                            
;                                                                            
; In:  -                                                                     
;                                                                            
; Out: -                                                                     
;                                                                            
; Description: Set new timer interrupt handing routine                       
;                                                                            
;ľ
;  
                align   4
setirqhandler:  pushad

                sub     bl,bl

                call    [_getirqvect]
                mov     [oldirq],edx

                mov     edx,offset irqhandler
                call    [_setirqvect]

                mov     esi,offset stubbuf
                call    _rmpmirqset
                mov     [oldrmirq],eax

                call    calcscreenrate

                popad
                ret


;͸͸
; CalcScreenRate                                                            
;ľ                                            
;                                                                            
; In:  -                                                                     
;                                                                            
; Out: -                                                                     
;                                                                            
; Description: Calculate sync rate for screen timer                          
;                                                                            
;ľ
;  
                align   4
calcscreenrate:

@@getcount:     call    @@waitretrace

                mov     al,36h
                out     43h,al
                sub     al,al
                out     40h,al
                out     40h,al

                call    @@waitretrace

                sub     al,al
                out     43h,al
                in      al,40h
                mov     ah,al
                in      al,40h
                xchg    al,ah
                neg     ax
                mov     bx,ax

                call    @@waitretrace

                mov     al,36h
                out     43h,al
                sub     al,al
                out     40h,al
                out     40h,al

                call    @@waitretrace

                sub     al,al
                out     43h,al
                in      al,40h
                mov     ah,al
                in      al,40h
                xchg    al,ah
                neg     ax

                sub     bx,ax

                ; if the difference between two vertical
                ; retrace times are bigger than |2| then
                ; get new values.
                cmp     bx,2
                jge     @@getcount
                cmp     bx,-2
                jle     @@getcount

                and     eax,0ffffh
                mov     [screentimer],eax

                ret

                align 4
@@waitretrace:  mov     dx,3dah
@@active:       in      al,dx
                test    al,8
                jnz      @@active
@@inactive:     in      al,dx
                test    al,8
                jz      @@inactive
                ret

;͸͸
; RestoreIrqHandler                                                         
;ľ                                            
;                                                                            
; In:  -                                                                     
;                                                                            
; Out: -                                                                     
;                                                                            
; Description: Restore old timer interrupt handler and reset rate            
;                                                                            
;ľ
;  
                align   4
restoreirqhandler:
                pushad

                cli

                ; bl = irq#
                sub     bl,bl

                ; set pmode interrupt vector
                mov     edx,[oldirq]
                call    [_setirqvect]

                ; set rmode interrupt vector
                mov     eax,[oldrmirq]
                call    _rmpmirqfree

                ; reset timer rate
                mov     al,36h
                out     43h,al
                sub     al,al
                out     40h,al
                out     40h,al

                sti

                popad
                ret


;͸͸
; PlayMusic                                                                 
;ľ                                            
;                                                                            
; In:  -                                                                     
;                                                                            
; Out: -                                                                     
;                                                                            
; Description: Update music                                                  
;                                                                            
;ľ
;  
                align   4
playmusic:      pushad

                ; speed
                dec     [speedcount]
                jnz     do_efx
                mov     al,[speed]
                mov     [speedcount],al

                ; patterndelay
                cmp     [pattdelaycount],0
                jz      @@nopattdelay
                dec     [pattdelaycount]
                jmp     do_efx
@@nopattdelay:

                ; is it end of pattern
                cmp     [pattrow],64
                jl      @@no_eopattern
                mov     [pattrow],0

                ; get next pattern number
@@next_order:   sub     eax,eax
                mov     ax,[order]
                inc     [order]
                mov     ebx,[module]
                mov     al,[eax+ebx+60h]
                cmp     al,254
                je      @@next_order
                cmp     al,255
                jne     @@no_eotune

                ; end of tune
                mov     [order],0
                jmp     @@next_order

                ; not end of tune
@@no_eotune:    and     eax,0ffh
                mov     eax,[patterns+eax*4]
                add     eax,2
                mov     [patternpos],eax

                ; not end of pattern
@@no_eopattern: inc     [pattrow]

                ; depack row
                call    depack_row

                call    init_efx

                call    startchannels

do_efx:         sub     ecx,ecx

@@ch_loop:      sub     eax,eax
                mov     al,[row_command+ecx]

                cmp     al,255
                jne     @@command
                sub     eax,eax
@@command:      pushad
                call    [defx+eax*4]
                popad

                inc     ecx
                cmp     ecx,16
                jl      @@ch_loop

                call    update_sd

                popa
                ret

;
; effects that must be updated every frame
;
                align   4
defx            dd      @@nothing               ; nothing
                dd      @@nothing               ; a
                dd      @@nothing               ; b
                dd      @@nothing               ; c
                dd      defx_volslide           ; d
                dd      defx_slidedown          ; e
                dd      defx_slideup            ; f
                dd      defx_toneporta          ; g
                dd      defx_vibrato            ; h
                dd      @@nothing               ; i
                dd      defx_arpeggio           ; j
                dd      defx_vibvslide          ; k
                dd      defx_tpvslide           ; l
                dd      @@nothing               ; m
                dd      @@nothing               ; n
                dd      @@nothing               ; o
                dd      @@nothing               ; p
                dd      @@nothing               ; q
                dd      @@nothing               ; r
                dd      @@nothing               ; s
                dd      @@nothing               ; t
                dd      @@nothing               ; u
                dd      @@nothing               ; v
                dd      @@nothing               ; w
                dd      @@nothing               ; x
                dd      @@nothing               ; y
                dd      @@nothing               ; z

                align   4
@@nothing:      ret

                ; command dxx - volume slide
                align   4
defx_volslide:  mov     al,[chan_volslide+ecx]
                call    volumeslide
                ret

                ; command exx - slidedown
                align   4
defx_slidedown: mov     al,[chan_slidedown+ecx]
                mov     ah,al
                and     ah,0f0h
                cmp     ah,0f0h
                je      @@noslide
                cmp     ah,0e0h
                je      @@noslide
                and     eax,0ffh
                shl     eax,2
                mov     ebx,[chan_period+ecx*4]
                add     ebx,eax
                mov     eax,ebx
                mov     [chan_period+ecx*4],eax
                mov     [sd_freq+ecx*4],eax
                or      [sd_status+ecx],sd_setfreq
@@noslide:      ret

                ; command fxx - slideup
                align   4
defx_slideup:   mov     al,[chan_slideup+ecx]
                mov     ah,al
                and     ah,0f0h
                cmp     ah,0f0h
                je      @@noslide
                cmp     ah,0e0h
                je      @@noslide
                and     eax,0ffh
                shl     eax,2
                mov     ebx,[chan_period+ecx*4]
                sub     ebx,eax
                mov     eax,ebx
                mov     [chan_period+ecx*4],eax
                mov     [sd_freq+ecx*4],eax
                or      [sd_status+ecx],sd_setfreq
@@noslide:      ret

                ; command gxx - tone portamento
                align   4
defx_toneporta: sub     eax,eax
                mov     al,[chan_toneporta+ecx]
                shl     eax,2

                mov     ebx,[chan_period+ecx*4]
                cmp     [chan_toperiod+ecx*4],ebx
                jg      @@tp_pos
                jl      @@tp_neg
                ret
@@tp_pos:       add     ebx,eax
                cmp     [chan_toperiod+ecx*4],ebx
                jg      @@tp_posno
                mov     ebx,[chan_toperiod+ecx*4]
@@tp_posno:     mov     [chan_period+ecx*4],ebx
                mov     eax,ebx
                mov     [sd_freq+ecx*4],eax
                or      [sd_status+ecx],sd_setfreq
                ret
@@tp_neg:       sub     ebx,eax
                cmp     [chan_toperiod+ecx*4],ebx
                jl      @@tp_negno
                mov     ebx,[chan_toperiod+ecx*4]
@@tp_negno:     mov     [chan_period+ecx*4],ebx
                mov     eax,ebx
                mov     [sd_freq+ecx*4],eax
                or      [sd_status+ecx],sd_setfreq
                ret

                ; command hxx - vibrato
                align   4
defx_vibrato:   mov     bl,[chan_vibrato+ecx]
                mov     bh,bl
                and     bl,0fh
                shr     bh,4
                mov     al,[chan_vibratopos+ecx]
                add     [chan_vibratopos+ecx],bh
                and     eax,63
                mov     al,[byte sintable+eax]
                imul    bl
                movsx   eax,ax
                sar     eax,4
                add     eax,[chan_period+ecx*4]
                mov     [sd_freq+ecx*4],eax
                or      [sd_status+ecx],sd_setfreq
                ret

                ; command jxx - arpeggio
                align   4
defx_arpeggio:  inc     [chan_arppos+ecx]
                cmp     [chan_arppos+ecx],3
                jne     @@no_loop
                mov     [chan_arppos+ecx],0
@@no_loop:      mov     al,[chan_arppos+ecx]
                cmp     al,0
                je      @@per1
                cmp     al,1
                je      @@per2
                cmp     al,2
                je      @@per3
                ret
@@per1:         mov     eax,[chan_arpper1+ecx*4]
                mov     [sd_freq+ecx*4],eax
                or      [sd_status+ecx],sd_setfreq
                ret
@@per2:         mov     eax,[chan_arpper2+ecx*4]
                mov     [sd_freq+ecx*4],eax
                or      [sd_status+ecx],sd_setfreq
                ret
@@per3:         mov     eax,[chan_arpper3+ecx*4]
                mov     [sd_freq+ecx*4],eax
                or      [sd_status+ecx],sd_setfreq
                ret

                ; command kxy - h00 + dxy
                align   4
defx_vibvslide: call    defx_vibrato
                mov     al,[chan_vibvslide+ecx]
                call    volumeslide
                ret

                ; command lxy - g00 + dxy
                align   4
defx_tpvslide:  call    defx_toneporta
                mov     al,[chan_tpvslide+ecx]
                call    volumeslide
                ret

; al = commandbyte
                align   4
volumeslide:    mov     bl,al
                mov     ah,al
                and     al,0fh
                shr     ah,4
                test    ah,ah
                jz      @@slidedown
                test    al,al
                jz      @@slideup
                cmp     ah,0fh
                jne     @@no_finedown
                test    al,al
                jg      @@fine
@@no_finedown:  cmp     al,0fh
                jne     @@no_fineup
                test    ah,ah
                jg      @@fine
@@no_fineup:    ret
@@slidedown:    mov     al,[chan_volume+ecx]
                and     bl,0fh
                sub     al,bl
                test    al,al
                jge     @@slidedown_ok
                sub     al,al
@@slidedown_ok: mov     [chan_volume+ecx],al
                and     eax,0ffh
                mov     [sd_vol+ecx],al
                or      [sd_status+ecx],sd_setvol
                ret
@@slideup:      mov     al,[chan_volume+ecx]
                shr     bl,4
                add     al,bl
                cmp     al,64
                jle     @@slideup_ok
                mov     al,64
@@slideup_ok:   mov     [chan_volume+ecx],al
                and     eax,0ffh
                mov     [sd_vol+ecx],al
                or      [sd_status+ecx],sd_setvol
                ret
@@fine:         ret


                align   4
depack_row:     push    eax ebx ecx

                mov     ebx,offset row_note
                mov     eax,-1
                mov     [ebx],eax
                mov     [ebx+4],eax
                mov     [ebx+8],eax
                mov     [ebx+12],eax

                mov     ebx,offset row_instrument
                sub     eax,eax
                mov     [ebx],eax
                mov     [ebx+4],eax
                mov     [ebx+8],eax
                mov     [ebx+12],eax

                mov     ebx,offset row_volume
                mov     eax,-1
                mov     [ebx],eax
                mov     [ebx+4],eax
                mov     [ebx+8],eax
                mov     [ebx+12],eax

                mov     ebx,offset row_command
                mov     eax,-1
                mov     [ebx],eax
                mov     [ebx+4],eax
                mov     [ebx+8],eax
                mov     [ebx+12],eax

                mov     ebx,offset row_cinfo
                sub     eax,eax
                mov     [ebx],eax
                mov     [ebx+4],eax
                mov     [ebx+8],eax
                mov     [ebx+12],eax

                mov     ebx,[patternpos]

@@ch_loop:      mov     al,[ebx]
                inc     ebx
                test    al,al
                jz      @@end_of_row

                mov     cl,al
                and     ecx,31

                test    al,32
                jz      @@no_noteinst
                mov     ah,[ebx]
                inc     ebx
                mov     [row_note+ecx],ah
                mov     ah,[ebx]
                inc     ebx
                mov     [row_instrument+ecx],ah
@@no_noteinst:  test    al,64
                jz      @@no_volume
                mov     ah,[ebx]
                inc     ebx
                mov     [row_volume+ecx],ah
@@no_volume:    test    al,128
                jz      @@no_command
                mov     ah,[ebx]
                inc     ebx
                mov     [row_command+ecx],ah
                mov     ah,[ebx]
                inc     ebx
                mov     [row_cinfo+ecx],ah
@@no_command:   jmp     @@ch_loop

@@end_of_row:   mov     [patternpos],ebx
                pop     ecx ebx eax
                ret

;
; standard efects
;
                align   4
init_efx:       sub     ecx,ecx

@@ch_loop:      mov     al,[row_instrument+ecx]
                test    al,al
                je      @@no_inst
                mov     [chan_instrument+ecx],al
                and     eax,0ffh
                dec     eax
                mov     bl,[sample_volume+eax]
                mov     [chan_volume+ecx],bl
                mov     ebx,[sample_start+eax*4]
                mov     [chan_start+ecx*4],ebx
                mov     al,[chan_volume+ecx]
                mov     [sd_vol+ecx],al
                or      [sd_status+ecx],sd_setvol
@@no_inst:      cmp     [row_note+ecx],255
                je      @@empty_note
                cmp     [row_command+ecx],7
                jne     @@no_porta
                mov     al,[row_note+ecx]
                mov     [row_note+ecx],255
                mov     ah,[chan_instrument+ecx]
                call    calcperiod
                mov     [chan_toperiod+ecx*4],eax
                jmp     @@empty_note
@@no_porta:     cmp     [row_command+ecx],12
                jne     @@no_lcomm
                mov     al,[row_note+ecx]
                mov     [row_note+ecx],255
                mov     ah,[chan_instrument+ecx]
                call    calcperiod
                mov     [chan_toperiod+ecx*4],eax
                jmp     @@empty_note
@@no_lcomm:     mov     al,[row_note+ecx]
                mov     [chan_note+ecx],al
                mov     ah,[chan_instrument+ecx]
                call    calcperiod
                mov     [chan_period+ecx*4],eax
@@empty_note:   cmp     [row_volume+ecx],255
                je      @@no_volume
                mov     al,[row_volume+ecx]
                mov     [chan_volume+ecx],al
                mov     al,[chan_volume+ecx]
                mov     [sd_vol+ecx],al
                or      [sd_status+ecx],sd_setvol
@@no_volume:
                sub     ebx,ebx
                mov     bl,[row_command+ecx]
                cmp     bl,255
                jne     @@command
                sub     ebx,ebx
@@command:      pushad
                call    [iefx+ebx*4]
                popad

                inc     ecx
                cmp     ecx,16
                jl      @@ch_loop
                ret

                align   4
iefx            dd      @@nothing               ; nothing
                dd      iefx_speed              ; a
                dd      iefx_orderjump          ; b
                dd      iefx_patternbreak       ; c
                dd      iefx_volslide           ; d
                dd      iefx_slidedown          ; e
                dd      iefx_slideup            ; f
                dd      iefx_toneporta          ; g
                dd      iefx_vibrato            ; h
                dd      @@nothing               ; i
                dd      iefx_arpeggio           ; j
                dd      iefx_vibvslide          ; k
                dd      iefx_tpvslide           ; l
                dd      iefx_set_position_flag  ; m
                dd      @@nothing               ; n
                dd      iefx_sampleoffset       ; o
                dd      @@nothing               ; p
                dd      @@nothing               ; q
                dd      @@nothing               ; r
                dd      @@nothing               ; s
                dd      iefx_tempo              ; t
                dd      @@nothing               ; u
                dd      iefx_globalvol          ; v
                dd      @@nothing               ; w
                dd      @@nothing               ; x
                dd      @@nothing               ; y
                dd      @@nothing               ; z

                align   4
@@nothing:      ret

                ; command axx - set speed
                align   4
iefx_speed:     mov     al,[row_cinfo+ecx]
                mov     [speed],al
                ret

                ; command bxx - order jump
                align   4
iefx_orderjump: sub     eax,eax
                mov     al,[row_cinfo+ecx]
                mov     [order],ax
                mov     [pattrow],64
                ret

                ; command cxx - break pattern to row #al
                align   4
iefx_patternbreak:
                mov     al,[row_cinfo+ecx]
                push    ax
@@next_order:   sub     eax,eax
                mov     ax,[order]
                inc     [order]
                mov     ebx,[module]
                mov     al,[eax+ebx+60h]
                cmp     al,254
                je      @@next_order
                cmp     al,255
                jne     @@no_eotune
                mov     [order],0
                jmp     @@next_order
@@no_eotune:    and     eax,0ffh
                mov     eax,[patterns+eax*4]
                add     eax,2
                pop     bx
                mov     [pattrow],bl
                test    bl,bl
                jz      @@next_orderdone
@@rowloop:      mov     bh,[eax]
                inc     eax
                test    bh,bh
                jz      @@no_comm
                test    bh,32
                jz      @@no_noteinst
                add     eax,2
@@no_noteinst:  test    bh,64
                jz      @@no_volume
                inc     eax
@@no_volume:    test    bh,128
                jz      @@no_comm
                add     eax,2
@@no_comm:      dec     bl
                jnz     @@rowloop
@@next_orderdone:
                mov     [patternpos],eax
                ret

                ; command dxx - volume slide
                align   4
iefx_volslide:  mov     al,[row_cinfo+ecx]
                mov     bl,al
                mov     ah,al
                and     al,0fh
                shr     ah,4
                test    ah,ah
                jz      @@slide
                test    al,al
                jz      @@slide
                cmp     ah,0fh
                jne     @@no_finedown
                test    al,al
                jg      @@finedown
@@no_finedown:  cmp     al,0fh
                jne     @@no_fineup
                test    ah,ah
                jg      @@fineup
@@no_fineup:    ret
@@slide:        test    bl,bl
                jz      @@no_fineup
                mov     [chan_volslide+ecx],bl
                ret
@@fineup:       mov     al,[chan_volume+ecx]
                shr     bl,4
                add     al,bl
                cmp     al,64
                jle     @@fineup_vol
                mov     al,64
@@fineup_vol:   mov     [chan_volume+ecx],al
                mov     [sd_vol+ecx],al
                or      [sd_status+ecx],sd_setvol
                ret
@@finedown:     mov     al,[chan_volume+ecx]
                and     bl,0fh
                sub     al,bl
                test    al,al
                jge     @@finedown_vol
                sub     al,al
@@finedown_vol: mov     [chan_volume+ecx],al
                mov     [sd_vol+ecx],al
                or      [sd_status+ecx],sd_setvol
                ret

                ; command exx - slidedown
                align   4
iefx_slidedown: mov     al,[row_cinfo+ecx]
                mov     ah,al
                mov     bl,al
                and     bl,0f0h
                cmp     bl,0f0h
                je      @@fine
                cmp     bl,0e0h
                je      @@xfine
                test    al,al
                jz      @@zero
                mov     [chan_slidedown+ecx],al
@@zero:         ret
@@fine:         mov     eax,[chan_period+ecx]
                sub     ebx,ebx
                mov     bl,ah
                shl     ebx,2
                add     eax,ebx
                mov     [chan_period+ecx],eax
                mov     [sd_freq+ecx*4],eax
                or      [sd_status+ecx],sd_setfreq
                ret
@@xfine:        mov     eax,[chan_period+ecx]
                sub     ebx,ebx
                mov     bl,ah
                add     eax,ebx
                mov     [chan_period+ecx],eax
                mov     [sd_freq+ecx*4],eax
                or      [sd_status+ecx],sd_setfreq
                ret

                ; command fxx - slideup
                align   4
iefx_slideup:   mov     al,[row_cinfo+ecx]
                mov     ah,al
                mov     bl,al
                and     bl,0f0h
                cmp     bl,0f0h
                je      @@fine
                cmp     bl,0e0h
                je      @@xfine
                test    al,al
                jz      @@zero
                mov     [chan_slideup+ecx],al
@@zero:         ret
@@fine:         mov     eax,[chan_period+ecx]
                sub     ebx,ebx
                mov     bl,ah
                shl     ebx,2
                sub     eax,ebx
                mov     [chan_period+ecx],eax
                mov     [sd_freq+ecx*4],eax
                or      [sd_status+ecx],sd_setfreq
                ret
@@xfine:        mov     eax,[chan_period+ecx]
                sub     ebx,ebx
                mov     bl,ah
                sub     eax,ebx
                mov     [chan_period+ecx],eax
                mov     [sd_freq+ecx*4],eax
                or      [sd_status+ecx],sd_setfreq
                ret

                ; command gxx - tone portamento
                align   4
iefx_toneporta: mov     al,[row_cinfo+ecx]
                test    al,al
                jz      @@no_porta
                mov     [chan_toneporta+ecx],al
@@no_porta:     ret

                ; command hxx - vibrato
                align   4
iefx_vibrato:   mov     al,[row_cinfo+ecx]
                test    al,al
                jz      @@zero
                mov     [chan_vibrato+ecx],al
                mov     [chan_vibratopos+ecx],0
@@zero:         ret

                ; command jxx - arpeggio
                align   4
iefx_arpeggio:  mov     al,[row_cinfo+ecx]
                mov     [chan_arppos+ecx],0
                test    al,al
                je      @@no_arp
                mov     [chan_arpeggio+ecx],al
                mov     esi,ecx
                mov     cl,al
                mov     ch,al
                and     cl,0fh
                shr     ch,4
                mov     bl,[chan_note+esi]
                mov     bh,[chan_instrument+esi]
                mov     ax,bx
                call    calcperiod
                mov     [chan_arpper1+esi*4],eax
                mov     ax,bx
                add     al,cl
                call    calcperiod
                mov     [chan_arpper2+esi*4],eax
                mov     ax,bx
                add     al,ch
                call    calcperiod
                mov     [chan_arpper3+esi*4],eax
@@no_arp:       ret

                ; command kxy - h00 + dxy
                align   4
iefx_vibvslide: mov     al,[row_cinfo+ecx]
                test    al,al
                jz      @@zero
                mov     [chan_vibvslide+ecx],al
@@zero:         ret

                ; command lxx - g00 + dxx
                align   4
iefx_tpvslide:  mov     al,[row_cinfo+ecx]
                test    al,al
                jz      @@zero
                mov     [chan_tpvslide+ecx],al
@@zero:         ret

                ; command mxx - set position flag
                align   4
iefx_set_position_flag:
                mov     al,[row_cinfo+ecx]
                mov     [position_flag],al
                ret

                ; command oxx - sample offset
                align   4
iefx_sampleoffset:
                mov     al,[row_cinfo+ecx]
                test    al,al
                jz      @@no_offset
                and     eax,0ffh
                shl     eax,8
                add     [chan_start+ecx*4],eax
@@no_offset:    ret

                ; command txx - set tempo
iefx_tempo:     mov     al,[row_cinfo+ecx]
                call    setirqrate
                ret

                ; command vxx - set global volume
                align   4
iefx_globalvol: mov     al,[row_cinfo+ecx]
                mov     [globalvolume+ecx],al
                ret

                align   4
startchannels:  sub     ecx,ecx

@@ch_loop:      cmp     [chan_instrument+ecx],0
                je      @@no_note
                cmp     [row_note+ecx],255
                je      @@no_note

                sub     ebx,ebx
                mov     bl,[chan_instrument+ecx]
                dec     bl

                cmp     [row_note+ecx],254
                je      @@no_note

                mov     eax,[chan_start+ecx*4]
                mov     [sd_start+ecx*4],eax

                mov     eax,[sample_loop+ebx*4]
                mov     [sd_loop+ecx*4],eax

                mov     eax,[sample_end+ebx*4]
                mov     [sd_end+ecx*4],eax

                mov     al,[chan_volume+ecx]
                mov     [sd_vol+ecx],al

                mov     eax,[chan_period+ecx*4]
                mov     [sd_freq+ecx*4],eax

                mov     al,[sample_flags+ebx]
                mov     [sd_mode+ecx],al
                or      [sd_status+ecx],sd_setsample+sd_setvol+sd_setfreq

@@no_note:      inc     ecx
                cmp     ecx,16
                jl      @@ch_loop
                ret

;͸͸
; Update_Sd                                                                 
;ľ                                            
;                                                                            
; In:  -                                                                     
;                                                                            
; Out: -                                                                     
;                                                                            
; Description: Transfer all changed variables to sound device                
;                                                                            
;ľ
;  
                align   4
update_sd:      sub     ecx,ecx
@@stopchannels: test    [sd_status+ecx],sd_setsample
                jz      @@no_stop
                mov     al,cl
                inc     al
                call    sd_selectvoice
                call    sd_waitvolramp
                sub     al,al
                call    sd_currentvolume
@@no_stop:      inc     ecx
                cmp     ecx,16
                jl      @@stopchannels

                sub     ecx,ecx
@@chanloop:     mov     al,cl
                inc     al
                call    sd_selectvoice

                test    [sd_status+ecx],sd_setfreq
                jz      @@no_freq
                mov     eax,[sd_freq+ecx*4]
                call    calcfreq
                call    sd_frequencycontrol
@@no_freq:      test    [sd_status+ecx],sd_setsample
                jz      @@no_sample
                call    sd_waitvolramp
                mov     al,3
                call    sd_voicecontrol
                mov     eax,[sd_start+ecx*4]
                call    sd_currentaddress
                mov     eax,[sd_loop+ecx*4]
                call    sd_startingaddress
                mov     eax,[sd_end+ecx*4]
                call    sd_endaddress
                mov     al,[sd_mode+ecx]
                call    sd_voicecontrol
@@no_sample:    test    [sd_status+ecx],sd_setvol
                jz      @@no_vol
                mov     al,[sd_vol+ecx]
                call    calcvolume
                call    sd_waitvolramp
                call    sd_currentvolume
@@no_vol:       inc     ecx
                cmp     ecx,16
                jne     @@chanloop

                mov     edi,offset sd_status
                sub     eax,eax
                mov     [edi],eax
                mov     [edi+4],eax
                mov     [edi+8],eax
                mov     [edi+12],eax
                ret

;͸͸
; CalcPeriod                                                                
;ľ                                            
;                                                                            
; In:  al - note                                                             
;      ah - instrument (1..99)                                               
;                                                                            
; Out: -                                                                     
;                                                                            
; Description: Calculate playing period for instrument at needed note        
;                                                                            
;ľ
;  
                align   4
calcperiod:     test    ah,ah
                je      @@no_per
                cmp     al,255
                je      @@no_per
                push    ebx ecx edx
                mov     cl,al
                mov     bl,ah
                and     eax,0fh         ; eax = note
                and     ecx,0f0h
                shr     ecx,4           ; ecx = octave
                and     ebx,0ffh        ; ebx = instrument
                mov     ax,[@@periodtable+eax*2]
                shr     ax,cl
                and     eax,0ffffh
                mov     edx,8363*16
                mul     edx
                sub     edx,edx
                mov     ebx,[sample_c2spd+ebx*4-4]
                div     ebx
                pop     edx ecx ebx
                ret
@@no_per:       mov     eax,1712
                ret

                align   4

                ; calculated from Amiga Hardware Reference Manual
@@periodtable   dw      1712,1616,1520,1440,1360,1280,1208,1144,1080,1016,960,904
                dw      856,808,760,720,,680 ; these values are for arpeggio

;͸͸
; CalcVolume                                                                
;ľ                                            
;                                                                            
; In:  al - Volume                                                           
;                                                                            
; Out: al - New Volume                                                       
;                                                                            
; Description: Calculate real volume                                         
;                                                                            
;ľ
;  
                align   4
calcvolume:     push    dx
                mov     dh,ah
                mov     dl,[globalvolume]
                mul     dl
                shr     ax,6
                mov     dl,[mastervolume]
                mul     dl
                shr     ax,6
                mov     ah,dh
                pop     dx
                ret

;͸͸
; CalcFreq                                                                  
;ľ                                            
;                                                                            
; In:  eax - period                                                          
;                                                                            
; Out: eax - frequency                                                       
;                                                                            
; Description: Convert period to frequency                                   
;                                                                            
;ľ
;  
                align   4
calcfreq:       push    ebx edx
                mov     ebx,eax
                mov     eax,8363*1712
                sub     edx,edx
                div     ebx
                pop     edx ebx
                ret

ends_sdrss      %sdrss_segname

end
