;
;               Copyright (c)1995 Juha Pohto
;
;
; Filename   : SDRSS.ASM
; Author     : Juha Pohto
; Date       : 950615
; Description: Slender's Sound System MAIN file
; Version    : 1.02
;

ideal
locals
p386

; pmode externals
extrn   v86r_eax:dword, v86r_ebx:dword, v86r_ecx:dword, v86r_edx:dword
extrn   v86r_esi:dword, v86r_edi:dword, v86r_ebp:dword
extrn   v86r_ah:byte, v86r_al:byte, v86r_bh:byte, v86r_bl:byte
extrn   v86r_ch:byte, v86r_cl:byte, v86r_dh:byte, v86r_dl:byte
extrn   v86r_ax:word, v86r_bx:word, v86r_cx:word, v86r_dx:word
extrn   v86r_si:word, v86r_di:word, v86r_bp:word
extrn   v86r_ds:word, v86r_es:word, v86r_fs:word, v86r_gs:word
extrn   _selcode:word, _seldata:word, _selzero:word, _lomembase:dword
extrn   _lomemtop:dword, _himembase:dword, _himemtop:dword, _pspa:dword
extrn   _code16a:dword, _code32a:dword, _getirqvect:dword, _setirqvect:dword
extrn   _sysbyte0:byte, _irqmode:word, _setselector:dword, _exitcode:byte
extrn   _getmem:near, _getlomem:near, _gethimem:near, _lomemsize:near
extrn   _himemsize:near, _ret:near, _exit:near, _getirqmask:near
extrn   _setirqmask:near, _rmpmirqset:near, _rmpmirqfree:near
extrn   _getselector:near, _freeselector:near

include         "settings.inc"
include         "macros.inc"

segment_sdrss   %sdrss_segname

                ifdef   loadconfig
sd_configfile   db      'sdrss.cfg',0
                endif

public          sd_config, sd_cardtype

label           sd_config
sd_cardtype     dd      ?               ; 1 = Ultrasound
                                        ; 2 = SB Pro
                                        ; 3 = SB 2.0
                                        ; 4 = SB 1.5
                                        ; 5 = SB 1.0
                                        ; 6 = No Sound
sd_base         dw      ?
sd_irq          dw      ?
sd_dma          dw      ?
sd_mixrate      dd      ?


;͸͸
; MACRO                                                                     
;ľ                                            
;                                                                            
; Sd_Func(Command)                                                           
;                                                                            
;ľ
;  
macro           sd_func command
                align   4
public          sd_&command
sd_&command:    push    edx
                mov     edx,[sd_cardtype]
                call    [@@jumptable+edx*4]
                pop     edx
                ret

                align   4
@@jumptable     dd      sd_nosound
                dd      us_&command
                dd      sb_&command
endm            sd_func

;͸͸
; Sd_NoSound                                                                        
;ľ                                                    
;                                                                                    
; In:  -                                                                             
;                                                                                    
; Out: -                                                                             
;                                                                                    
; Description:                                                                       
;                                                                                    
;ľ
;  
                align   4
sd_nosound:     ret


;͸͸
; Sd_Initialize                                                                     
;ľ                                                    
;                                                                                    
; In:  -                                                                             
;                                                                                    
; Out: -                                                                             
;                                                                                    
; Description: Initialize SoundDevice                                                
;                                                                                    
;ľ
;  
                align   4
public          sd_initialize
sd_initialize:
                if      loadconfig
                mov     edx,offset sd_configfile
                call    sd_loadconfig
                endif

                if      getconfig
                call    sd_getconfig
                endif

                if      envconfig
                call    sd_envconfig
                endif

                call    sd_detect

                push    esi
                mov     esi,[sd_cardtype]
                call    [@@jumptable+esi*4]
                pop     esi

                ret

                align   4
@@jumptable     dd      sd_nosound
                dd      us_initialize
                dd      sb_initialize

;͸͸
; Sd_Detect                                                                         
;ľ                                                    
;                                                                                    
; In:  -                                                                             
;                                                                                    
; Out: -                                                                             
;                                                                                    
; Description: Detect soundcard                                                      
;                                                                                    
;ľ
;  
                align   4
sd_detect:      pushad

                cmp     [sd_cardtype],6
                je      @@ns_found

                cmp     [sd_cardtype],1
                je      @@us_found

@@sb_found:     mov     eax,[sd_cardtype]
                sub     eax,2
                mov     al,[@@sb_types+eax]
                mov     [sb_type],al
                mov     [sd_cardtype],2
                mov     ax,[sd_base]
                mov     [sb_base],ax
                mov     ax,[sd_irq]
                mov     [sb_irq],ax
                mov     ax,[sd_dma]
                mov     [sb_dma],ax
                mov     eax,[sd_mixrate]
                mov     [sb_mixrate],eax
                call    sb_detect
                jc      @@ns_found
                popad
                ret

@@sb_types      db      3,2,1,0

                align   4
@@us_found:     mov     [sd_cardtype],1
                mov     ax,[sd_base]
                mov     [us_base],ax
                call    us_detect
                jc      @@ns_found
                popad
                ret

                align   4
@@ns_found:     mov     [sd_cardtype],0
                popad
                ret

;͸͸
; Sd_UnInitialize                                                           
;ľ                                            
;                                                                            
; In:  -                                                                     
;                                                                            
; Out: -                                                                     
;                                                                            
; Description: Uninitialize SoundDevice                                      
;                                                                            
;ľ
;  
                sd_func uninitialize

;͸͸
; Sd_PokeData                                                               
;ľ                                            
;                                                                            
; In:  al - value                                                            
;      edi - address                                                         
;                                                                            
; Out: -                                                                     
;                                                                            
; Description:                                                               
;                                                                            
;ľ
;  
                sd_func pokedata

;͸͸
; Sd_PeekData                                                               
;ľ                                            
;                                                                            
; In:  edi - address                                                         
;                                                                            
; Out: al - value                                                            
;                                                                            
; Description:                                                               
;                                                                            
;ľ
;  
                sd_func peekdata

;͸͸
; Sd_SelectVoice                                                            
;ľ                                            
;                                                                            
; In:  al - Voice                                                            
;                                                                            
; Out: -                                                                     
;                                                                            
; Description: Select active voice                                           
;                                                                            
;ľ
;  
                sd_func selectvoice

;͸͸
; Sd_FrequencyControl                                                       
;ľ                                            
;                                                                            
; In:  eax - Frequency                                                       
;                                                                            
; Out: -                                                                     
;                                                                            
; Description: Set Frequency for active voice                                
;                                                                            
;ľ
;  
                sd_func  frequencycontrol

;͸͸
; Sd_CurrentAddress                                                         
;ľ                                            
;                                                                            
; In:  eax - address                                                         
;                                                                            
; Out: -                                                                     
;                                                                            
; Description: Sets voice current address                                    
;                                                                            
;ľ
;  
                sd_func currentaddress

;͸͸
; Sd_StartingAddress                                                        
;ľ                                            
;                                                                            
; In:  eax - address                                                         
;                                                                            
; Out: -                                                                     
;                                                                            
; Description: Set voice starting address                                    
;                                                                            
;ľ
;  
                sd_func startingaddress

;͸͸
; Sd_EndAddress                                                             
;ľ                                            
;                                                                            
; In:  eax - address                                                         
;                                                                            
; Out: -                                                                     
;                                                                            
; Description: Set voice endaddress                                          
;                                                                            
;ľ
;  
                sd_func endaddress

;͸͸
; Sd_PanPosition                                                            
;ľ                                            
;                                                                            
; In:  al - panning                                                          
;                                                                            
; Out: -                                                                     
;                                                                            
; Description: Only used if soundcard is GUS!                                
;                                                                            
;ľ
;  
                sd_func panposition

;͸͸
; Sd_CurrentVolume                                                          
;ľ                                            
;                                                                            
; In:  al - Volume                                                           
;                                                                            
; Out: -                                                                     
;                                                                            
; Description: Set current volume                                            
;                                                                            
;ľ
;  
                align   4
public          sd_currentvolume
sd_currentvolume:push    edx
                mov     edx,[sd_cardtype]
                call    [@@jumptable+edx*4]
                pop     edx
                ret

                align   4
@@jumptable     dd      sd_nosound
                ife     us_fast
                dd      us_rampvolume
                else
                dd      us_currentvolume
                endif
                dd      sb_currentvolume

;͸͸
; Sd_WaitVolRamp                                                            
;ľ                                            
;                                                                            
; In:  -                                                                     
;                                                                            
; Out: -                                                                     
;                                                                            
; Description:                                                               
;                                                                            
;ľ
;  
                align   4
                sd_func waitvolramp

;͸͸
; Sd_VoiceControl                                                           
;ľ                                            
;                                                                            
; In:  al - Controlbyte                                                      
;                                                                            
; Out: -                                                                     
;                                                                            
; Description:                                                               
;               BIT   DESCRIPTION                                            
;               ---   ------------------------------------------------       
;                0     Voice Stopped                                         
;                1     Stop Voice                                            
;                2     -                                                     
;                3     Loop enable                                           
;                4     -                                                     
;                5     -                                                     
;                6     -                                                     
;                7     -                                                     
;                                                                            
;ľ
;  
                sd_func voicecontrol

;͸͸
; Sd_GetMem                                                                 
;ľ                                            
;                                                                            
; In:  eax - size                                                            
;                                                                            
; Out: cf=1 => Not enought memory                                            
;      eax - address of memoryblock                                          
;                                                                            
; Description: Allocate DRAM                                                 
;                                                                            
;ľ
;  
                sd_func getmem

include         "sblib.asm"
include         "uslib.asm"

                ifdef   getconfig
include         "gconfig.asm"
                endif

                ifdef   loadconfig
include         "lconfig.asm"
                endif

                ifdef   envconfig
include         "econfig.asm"
                endif

ends_sdrss      %sdrss_segname

end
